//+------------------------------------------------------------------+
//|                                                    Angela_v3.mq4 |
//|                                         Copyright  2007,  |
//|                                            http://liteforex.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, "
#property link "http://liteforex.net/"

extern string s1 = " ";
extern bool setbuy = true;
extern bool setsell = true;
extern bool CloseAll = false;
extern bool DelLimitOnly = true;
extern bool useGlobalStop = true;
extern int globalstoploss = 0;
extern string s2 = " ";
extern int step = 50;
extern double lot = 0.2;
extern int kolorders = 10;
extern string s3 = " ";
extern int takeprofit = 50;
extern int stoploss = 0;
extern int slipp = 3;
extern int magic = 03062007;


int ticket;

int init()
   {
   return(0);
   }
int deinit()
   {
   return(0);
   }
int start()
   {
   if(CloseAll)
      {
      CloseAll();
      return(0);
      }

   if(setbuy)
      SetBuy();
   if(setsell)
      SetSell();

   if(useGlobalStop)
      {
      SetGlobalStop();
      }
   return(0);
   }
//+------------------------------------------------------------------+
void SetGlobalStop()
   {
   //       
   double buystopprice = FindBuyStopPrice();
   double sellstopprice = FindSellStopPrice();
   Print(buystopprice," - ",sellstopprice);
   //     
   for(int pos=OrdersTotal()-1; pos>=0; pos--)
      {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

      if(OrderSymbol() !=Symbol())continue;
      if(OrderMagicNumber() != magic)continue;
      
      if(setbuy && OrderType() != OP_SELL && OrderType() != OP_SELLLIMIT && OrderType() != OP_SELLSTOP)
         {
         ModifyStopLoss(buystopprice-globalstoploss*Point);
         
         }
      }
      for(int pos1=OrdersTotal()-1; pos1>=0; pos1--)
      {
      if(OrderSelect(pos1,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

      if(OrderSymbol() !=Symbol())continue;
      if(OrderMagicNumber() != magic)continue;
      
      if(setsell && OrderType() != OP_BUY && OrderType() != OP_BUYLIMIT && OrderType() != OP_BUYSTOP)
         {
         ModifyStopLoss(sellstopprice+globalstoploss*Point);
         }
      }
   
   }

double FindBuyStopPrice()
   {
   double buypredprice;
      int ch = 0;
   if(setbuy)
      {
      //   
         for(int pos=OrdersTotal()-1; pos>=0; pos--)
            {
            if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

            if(OrderSymbol() !=Symbol())continue;
            if(OrderMagicNumber() != magic)continue;
            if(OrderType() != OP_BUY && OrderType() != OP_BUYLIMIT && OrderType() != OP_BUYSTOP)continue;
            ch++;
            if(ch == 1)
               {
               buypredprice = OrderOpenPrice();
               continue;
               }
            if(OrderOpenPrice()<buypredprice)
               {
               buypredprice = OrderOpenPrice();
               }
               
            }

      }
      
   return(buypredprice);
   }

double FindSellStopPrice()
   {
   double predprice;
   int ch = 0;
   if(setsell)
      {
      //  
             for(int pos1=OrdersTotal()-1; pos1>=0; pos1--)
            {
            if(OrderSelect(pos1,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

            if(OrderSymbol() !=Symbol())continue;
            if(OrderMagicNumber() != magic)continue;
            if(OrderType() != OP_SELL && OrderType() != OP_SELLLIMIT && OrderType() != OP_SELLSTOP)continue;
            ch++;
            if(ch == 1)
               {
               predprice = OrderOpenPrice();
               continue;
               }
            if(OrderOpenPrice()>predprice)
               {
               predprice = OrderOpenPrice();
               }
               
            }

      }         
   return(predprice);
   }

   
void ModifyStopLoss(double ldStopLoss)
   {
  int fm;
  Print(OrderTicket(),"  ",OrderOpenPrice(),"  ",ldStopLoss,"  ",OrderTakeProfit());
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if(fm==0 || fm==-1) {Print("    stop-loss  #",GetLastError());}
  else {Print("   stop-loss: ",ldStopLoss);}
   }// 



void CloseAll()
   {
   int result,error;
   double price;
   int cmd;

   for(int pos=OrdersTotal()-1; pos>=0; pos--)
      {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

      if(OrderSymbol() !=Symbol())continue;
      if(OrderMagicNumber() != magic)continue;

      cmd=OrderType();
      if(cmd == OP_BUY || cmd == OP_SELL)
         {
         while(true)
            {
            if(cmd==OP_BUY) price=Bid;
            if(cmd==OP_SELL) price=Ask;
            result=OrderClose(OrderTicket(),OrderLots(),price,3,Red);
            if(result!=TRUE) { error=GetLastError(); Print("LastError = ",error); }
            else error=0;
            if(error==135) RefreshRates();
            else break;
            } 
         }

      }

   DeleteOrders(OP_BUYSTOP);
   DeleteOrders(OP_BUYLIMIT);
   DeleteOrders(OP_SELLSTOP);
   DeleteOrders(OP_SELLLIMIT); 
   }


void DeleteOrders(int type) 
   {
   int cnt = OrdersTotal();
   for (int i=cnt-1; i>=0; i--) 
      {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue; 
      if (OrderType() != type) continue;
      if(OrderSymbol() !=Symbol())continue;
      if(OrderMagicNumber() != magic)continue;
      if (type == OP_BUYSTOP || type == OP_SELLSTOP) OrderDelete(OrderTicket());
      if (type == OP_BUYLIMIT || type == OP_SELLLIMIT) OrderDelete(OrderTicket()); 
      }
   }

void SetBuy()
   {
   if(DelLimitOnly)
      {
      if((SchOrders(OP_BUY)+SchOrders(OP_BUYSTOP))==0 && SchOrders(OP_BUYLIMIT)!=0)
         {
         DeleteOrders(OP_BUYLIMIT);
         return(0);
         }
   }

   if((SchOrders(OP_BUY)+SchOrders(OP_BUYSTOP)+SchOrders(OP_BUYLIMIT))==0)
      {
      double pricebuystop = Ask;
      for(int i = 1;i<=kolorders/2;i++)
      {
      pricebuystop = pricebuystop+step*Point; 
      ticket = OrderSend(Symbol(),OP_BUYSTOP,lot,pricebuystop,slipp,Los(OP_BUYSTOP,pricebuystop
),Take(OP_BUYSTOP,pricebuystop)," BUYstop  #2",magic,0,Green);
      if (ticket<0)
         {
         Print("   BUYstop#",GetLastError());
         return(0); 
         }

      }
   double pricebuylimit = Ask;
   for(int ii = 1;ii<=kolorders/2;ii++)
      {
      pricebuylimit = pricebuylimit-step*Point; 
      ticket = OrderSend(Symbol(),OP_BUYLIMIT,lot,pricebuylimit,slipp,Los(OP_BUYLIMIT,pricebuylimit),Take(OP_BUYLIMIT,pricebuylimit)," BUYlimit  #2",magic,0,Green);
      if (ticket<0)
         {
         Print("   BUYlimit#",GetLastError());
         return(0); 
         }

      }
   }
   if((SchOrders(OP_BUY)+SchOrders(OP_BUYSTOP)+SchOrders(OP_BUYLIMIT))<kolorders)
   {
   OpenOrder(OP_BUY);
   }
   }

void SetSell()
{

if(DelLimitOnly)
{
if((SchOrders(OP_SELL)+SchOrders(OP_SELLSTOP))==0 && SchOrders(OP_SELLLIMIT)!=0)
{
DeleteOrders(OP_SELLLIMIT);
return(0);
}
}

if((SchOrders(OP_SELL)+SchOrders(OP_SELLSTOP)+SchOrders(OP_SELLLIMIT))==0)
{
double pricesellstop = Bid;
for(int i = 1;i<=kolorders/2;i++)
{

pricesellstop = pricesellstop-step*Point;

ticket = OrderSend(Symbol(),OP_SELLSTOP,lot,pricesellstop,slipp,Los(OP_SELLSTOP,pricesellstop),Take(OP_SELLSTOP,pricesellstop)," SELLstop  #2",magic,0,Green);
if (ticket<0)
{
Print("   SELLstop#",GetLastError());
return(0); 
}
}
double priceselllimit = Bid;
for(int ii = 1;ii<=kolorders/2;ii++)
{

priceselllimit = priceselllimit+step*Point;

ticket = OrderSend(Symbol(),OP_SELLLIMIT,lot,priceselllimit,slipp,Los(OP_SELLLIMIT,priceselllimit),Take(OP_SELLLIMIT,priceselllimit)," SELLlimit  #2",magic,0,Green);
if (ticket<0)
{
Print("   SELLlimit#",GetLastError());
return(0); 
}
}

}
if((SchOrders(OP_SELL)+SchOrders(OP_SELLSTOP)+SchOrders(OP_SELLLIMIT))<kolorders)
{
OpenOrder(OP_SELL);
}
}

void OpenOrder(int type)
{ 
for(int h = OrdersHistoryTotal()-1;h>=0;h--)
{
OrderSelect(h,SELECT_BY_POS,MODE_HISTORY);

if(OrderSymbol() !=Symbol())continue;
if(OrderMagicNumber() != magic)continue;

if(OrderType() == type)
{
break;
}
}
if(type == OP_BUY && OrderProfit()>0)
{
ticket = OrderSend(Symbol(),OP_BUYLIMIT,lot,OrderOpenPrice(),slipp,Los(OP_BUYLIMIT,OrderOpenPrice()),Take(OP_BUYLIMIT,OrderOpenPrice())," BUYLIMIT  #2",magic,0,Green);
if (ticket<0)
{
Print("   BUYLIMIT#",GetLastError());
return(0); 
}
}
if(type == OP_BUY && OrderProfit()<0)
{
ticket = OrderSend(Symbol(),OP_BUYSTOP,lot,OrderOpenPrice(),slipp,Los(OP_BUYSTOP,OrderOpenPrice()),Take(OP_BUYSTOP,OrderOpenPrice())," BUYStop  #2",magic,0,Green);
if (ticket<0)
{
Print("   BUYStop#",GetLastError());
return(0); 
}
}
if(OrderType() == OP_SELL && OrderProfit()>0)
{
ticket = OrderSend(Symbol(),OP_SELLLIMIT,lot,OrderOpenPrice(),slipp,Los(OP_SELLLIMIT,OrderOpenPrice()),Take(OP_SELLLIMIT,OrderOpenPrice())," SELLLIMIT  #2",magic,0,Green);
if (ticket<0)
{
Print("   SELLLIMIT#",GetLastError());
return(0); 
}
}
if(OrderType() == OP_SELL && OrderProfit()<0)
{
ticket = OrderSend(Symbol(),OP_SELLSTOP,lot,OrderOpenPrice(),slipp,Los(OP_SELLSTOP,OrderOpenPrice()),Take(OP_SELLSTOP,OrderOpenPrice())," SELLStop  #2",magic,0,Green);
if (ticket<0)
{
Print("   SELLStop#",GetLastError());
return(0); 
}
}
} 

double Take(int type,double price)
{
if(type == OP_BUY)
{
if(takeprofit == 0)
{
return(0);
}
else
{
return(Ask+takeprofit*Point);
}
}
if(type == OP_BUYSTOP || type == OP_BUYLIMIT)
{
if(takeprofit == 0)
{
return(0);
}
else
{
return(price+takeprofit*Point);
}
}
if(type == OP_SELL)
{
if(takeprofit == 0)
{
return(0);
}
else
{
return(Bid-takeprofit*Point);
}
}
if(type == OP_SELLSTOP || type == OP_SELLLIMIT)
{
if(takeprofit == 0)
{
return(0);
}
else
{
return(price-takeprofit*Point);
}
}
}

double Los(int type,double price)
{
if(type == OP_BUY)
{
if(stoploss == 0)
{
return(0);
}
else
{
return(Ask-stoploss*Point);
}
}
if(type == OP_BUYSTOP || type == OP_BUYLIMIT)
{
if(stoploss == 0)
{
return(0);
}
else
{
return(price-stoploss*Point);
}
}
if(type == OP_SELL)
{
if(stoploss == 0)
{
return(0);
}
else
{
return(Bid+stoploss*Point);
}
}
if(type == OP_SELLSTOP || type == OP_SELLLIMIT)
{
if(stoploss == 0)
{
return(0);
}
else
{
return(price+stoploss*Point);
}
}
} 

int SchOrders(int type)
{
//       

int SchBuyStop=0; 
int SchSellStop=0; 
int SchBuyLimit=0; 
int SchBuy=0; 
int SchSell=0; 
int SchSellLimit=0;
for (int i=OrdersTotal()-1;i>=0;i--)
{// 
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
{//    

if(OrderSymbol() !=Symbol())continue;
if(OrderMagicNumber() != magic)continue;

if(OrderType()==OP_BUYSTOP) 
SchBuyStop++;
if(OrderType()==OP_SELLSTOP) 
SchSellStop++; 
if(OrderType()==OP_SELLLIMIT)
SchSellLimit++;
if(OrderType()==OP_BUYLIMIT)
SchBuyLimit++;
if(OrderType()==OP_BUY) 
SchBuy++;
if(OrderType()==OP_SELL)
SchSell++;
}//    
}// 
if(type == OP_BUY) return(SchBuy);
if(type == OP_SELL)return(SchSell);
if(type == OP_BUYSTOP)return(SchBuyStop);
if(type == OP_SELLSTOP)return(SchSellStop);
if(type == OP_SELLLIMIT)return(SchSellLimit);
if(type == OP_BUYLIMIT)return(SchBuyLimit);
}
